#ifndef TREE_GAME_H
#define TREE_GAME_H

typedef enum {gs_none,
              gs_title, gs_playing, gs_gameover,
              gs_end
} game_state_t;

typedef enum {us_none,
              us_chee_normal, us_chee_catching,
} unit_state_t;

typedef struct {
    LCD_unit_t unit;
    int step_ctr;
} unit_manager_t;    

typedef struct {
    LCD_unit_t unit;
    int x;
} unit_chee_t;

typedef struct {
    LCD_unit_t unit;
    int x, y;
    int is_alive;
    int fall_ctr;
} unit_gondin_t;


typedef enum {ut_manager, ut_chee, ut_gondin} unit_type_t;

typedef struct {
    int score;
    int miss;
    int level;
    int current_gondin_max;
    int current_respawn_wait;
    int exp;
} game_t;

#define GAMEOVER_WAIT 100
#define GONDIN_FALL_WAIT 20
#define GONDIN_MAX 4

#define GAME_MISS_LIMIT 3
#define GAME_SCORE_LIMIT 9999
//#define GAME_LEVELUP_EXP 5
#define GAME_LEVELUP_EXP 2
#define GONDIN_RESPAWN_LEVEL_MAX 3
#define GONDIN_RESPAWN_BASEWAIT 120
#define GONDIN_RESPAWN_DEC 40

#define GAME_LEVEL_MAX                          \
    ((GONDIN_RESPAWN_LEVEL_MAX+1)*GONDIN_MAX-1)

#endif // TREE_GAME_H
